/*

DISCLAIMER 

InSitu is provided as is, without any kind of guarantees or warranty. There is 
no documentation. The author does not provide any kind of support to users of 
this source code and is not responsible for any kind of problems or damages 
resulting from its use. 

The source code is the result of a long iterative design process for a research 
prototype and was never intended to be used in any kind of product. In general, 
the code cannot be expected to compile in any straightforward manner on your 
computer system, since the robot on which it was developed, has a custom design. 

*/
/* Rene Schaad                                                    */
/* Departement of Computer Science, Univ. of Zurich, Switzerland  */
/* schaad@ifi.unizh.ch                                            */

#include <assert.h>
#include "CKernel.h"

//---- CKernel ---------------------------------------------------------


CKernel::CKernel() 
{
	kernel = NULL;
	SetEdge3by3();
}

CKernel::~CKernel()
{
	delete kernel;
}

void CKernel::SetEdge3by3(void)
{
	delete kernel;
	kernel = new short [9];
	assert(kernel!=0);
	kernel[0] = -1;
	kernel[1] = -1;
	kernel[2] = -1;
	kernel[3] = -1;
	kernel[4] =  8;
	kernel[5] = -1;
	kernel[6] = -1;
	kernel[7] = -1;
	kernel[8] = -1;
	map_width=map_height=3;
}

void CKernel::SetSmooth3by3(void)
{
	delete kernel;
	kernel = new short [9];
	assert(kernel!=0);
	kernel[0] = 1;
	kernel[1] = 1;
	kernel[2] = 1;
	kernel[3] = 1;
	kernel[4] = 8;
	kernel[5] = 1;
	kernel[6] = 1;
	kernel[7] = 1;
	kernel[8] = 1;
	map_width=map_height=3;
}



