/*

DISCLAIMER 

InSitu is provided as is, without any kind of guarantees or warranty. There is 
no documentation. The author does not provide any kind of support to users of 
this source code and is not responsible for any kind of problems or damages 
resulting from its use. 

The source code is the result of a long iterative design process for a research 
prototype and was never intended to be used in any kind of product. In general, 
the code cannot be expected to compile in any straightforward manner on your 
computer system, since the robot on which it was developed, has a custom design. 

*/

#ifndef _TimeArith_h_
#define _TimeArith_h_

/* Rene Schaad                                                    */
/* Departement of Computer Science, Univ. of Zurich, Switzerland  */
/* schaad@ifi.unizh.ch                                            */

#include "defines.h"
#ifdef __QNX__
	#include <sys/types.h>
#else  
	#include <sys/stdtypes.h>
#endif

// timing functions
// all in milliseconds

class RealTime {
public:
	time_t	CurrentTime(void);
	void	Sleep(time_t msecs);
};

class StopWatch : public RealTime {
public:
	StopWatch(boolean start_=FALSE);
	void	Start(void);
	time_t	Lap(void);
	time_t	Stop(void);
	boolean Running(void);
private:
	time_t	start_time;
	boolean running;
};

class Countdown : public RealTime {
public:
	Countdown(time_t c_length=0);
	void	Count(time_t c_length);
	time_t	Remaining(void);
	boolean	Expired(void);
private:
	time_t	end_time;	// started at this time
};


#endif	/* _TimeArith_h_ */
