/*

DISCLAIMER 

InSitu is provided as is, without any kind of guarantees or warranty. There is 
no documentation. The author does not provide any kind of support to users of 
this source code and is not responsible for any kind of problems or damages 
resulting from its use. 

The source code is the result of a long iterative design process for a research 
prototype and was never intended to be used in any kind of product. In general, 
the code cannot be expected to compile in any straightforward manner on your 
computer system, since the robot on which it was developed, has a custom design. 

*//* Rene Schaad                                                    */
/* Computer Science Institute, University of Zurich, Switzerland  */
/* schaad@ifi.unizh.ch                                            */

#include <stdlib.h>
#include <stdio.h>

#include "Argscan.h"
#include "Interpreter.h"

#define USAGE             " command_file"
#define N_CMDARGS         1

/************************************
 *  TODO
 *  
 *
 *************************************/
 
int main(int argc, char *argv[])
{
	char         	*bufptr,cmd_file_name[100];   /* holds command line arg filename */
	int				c;
	FILE			*infile;
	char 			cmd_buffer[20000];
	
	SHOW_USAGE_TEST( exit(1), N_CMDARGS, USAGE ); 
	SCAN_STR_ARGV( exit(1), 1, cmd_file_name );   
	
	Parser		intp;
	
	
	/* -------- READ FILES ---------------------*/
	
	if ((infile = fopen(cmd_file_name,"r"))==NULL) {
		printf("ERROR: could not open file: %s\n",cmd_file_name);
		exit(1);
	} else {
		printf("File was opened successfully: %s\n",cmd_file_name);
	}
	
	bufptr=cmd_buffer;
	while ((c=getc(infile))!=EOF) {
		*(bufptr++)=c;
	}
	*bufptr=0;
	
	printf("File was read successfully\n");
	
	printf("%s\n",cmd_buffer);

	intp.Parse(cmd_buffer);
	
	intp.PrintTree();
	intp.symtab.PrintAll();
	
	fclose(infile);
	exit(0);
}

