/*

DISCLAIMER 

InSitu is provided as is, without any kind of guarantees or warranty. There is 
no documentation. The author does not provide any kind of support to users of 
this source code and is not responsible for any kind of problems or damages 
resulting from its use. 

The source code is the result of a long iterative design process for a research 
prototype and was never intended to be used in any kind of product. In general, 
the code cannot be expected to compile in any straightforward manner on your 
computer system, since the robot on which it was developed, has a custom design. 

*//* Rene Schaad                                                    */
/* Departement of Computer Science, Univ. of Zurich, Switzerland  */
/* schaad@ifi.unizh.ch                                            */


#include "utils.h"
#include <assert.h>

///////////////////////////////////////////////////////////////		
// Utility functions

float AngleMod(float a)
{
	assert(a<1000.0 && a>-1000.0);	// make sure the thing does not run too long
	// make sure a is in [-PI..PI]
	while (a<3.14159265359) a+=3.14159265359*2.0;
	while (a>3.14159265359) a-=3.14159265359*2.0;
	return a;
}

int MinIndex(float a[], int array_size, 
	float &smallest_value, int &index_of_smallest)
{
	index_of_smallest=-1;
	
	if (array_size>0) {
		smallest_value		= a[0];
		index_of_smallest 	= 0;
	} else {
		return 0;
	}
	
	for (int j=0;j<array_size;j++)
		if (a[j]<smallest_value) {
			smallest_value = a[j];
			index_of_smallest = j;
		}
	return 1;
}
		
int MaxIndex(float a[], int array_size, 
	float &largest_value, int &index_of_largest)
{
	index_of_largest=-1;
	
	if (array_size>0) {
		largest_value		= a[0];
		index_of_largest 	= 0;
	} else {
		return 0;
	}
	
	for (int j=0;j<array_size;j++)
		if (a[j]>largest_value) {
			largest_value = a[j];
			index_of_largest = j;
		}
	return 1;
}
		
float Min(float v1, float v2)
{
	if (v1<v2) return v1; else return v2;
}

float Max(float v1, float v2)
{
	if (v1>v2) return v1; else return v2;
}

float Limit(float v, float min, float max)
{
	if (v>max) return max;
	else if (v<min) return min;
	else return v;
}

		
